#include "APPEVENT.CH"
#include "XBP.CH"
#include "common.CH"

PROCEDURE AppSys
RETURN

PROCEDURE Main
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg
LOCAL lExit       := .F.
LOCAL aPos        := { 0, 0 }
LOCAL aSize       := { 0, 0 }

*  SetCancel(.F.)

   oDlg := SaveDlg():New()
   oDlg:taskList := .T.
   oDlg:Titlebar := .T.
   oDlg:maxbutton := .F.
   oDlg:minbutton := .F.
   oDlg:title := "Backup User "
   oDlg:icon := 1
   oDlg:border := XBPDLG_NO_BORDER
   oDlg:close := { || lExit := .T. }
   oDlg:oPBtarget:activate  := {|| oDlg:OpenTargetDir()  }
   oDlg:Create()
   CenterControl(oDlg)
   oDlg:Show()

   SetAppFocus(oDlg)

   lExit := .F.
   DO WHILE !lExit
      nEvent := APPEVENT( @mp1, @mp2, @oXbp )
      DO CASE
         CASE nEvent = xbeP_Keyboard .AND. mp1 == xbeK_ESC

         CASE nEvent = xbeP_Keyboard .AND. mp1 == xbeK_ALT_T
            PostAppEvent(xbeP_Activate,,,oDlg:oPBtarget)

         OTHERWISE
            oXbp:handleEvent( nEvent, mp1, mp2 )
      ENDCASE
   ENDDO

   oDlg:destroy()

RETURN

* ------------------------------------------------------------------------- *

CLASS SaveForm FROM XbpDialog
EXPORTED:
   VAR oGRPtarget
   VAR oCombo
   VAR oPBtarget

   METHOD init
   METHOD create
ENDCLASS

METHOD SaveForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {1,3}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "12.Arial" } )

   IF Empty(aSize) == .T.
      IF IsMemberVar(self,"ClientSize") == .T.
         aSize := {0,0}
      ELSE
         aSize := {716,383}
      ENDIF
   ENDIF

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   IF aSize[1] == 0 .AND. aSize[2] == 0
      ::XbpDialog:ClientSize := {700,349}
   ENDIF
   ::XbpDialog:taskList := .T.

   ::oGRPtarget := XbpStatic():new(    ::drawingArea, , {  8,112}, {688,114}, { { XBP_PP_BGCLR, -255 } } )
   ::oGRPtarget:caption := "to"
   ::oGRPtarget:clipSiblings := .T.
   ::oGRPtarget:type := XBPSTATIC_TYPE_GROUPBOX

   ::oCombo     := XbpCombobox():new(  ::oGRPtarget , , {  8,  8}, {676, 76}, { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD} } )
   ::oCombo:tabstop := .T.

   ::oPBtarget  := XbpPushButton():new(::oGRPtarget , , {  4,  4}, {100, 36}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::oPBtarget:caption := "~Target"
   ::oPBtarget:tabStop := .T.

RETURN self

METHOD SaveForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::oGRPtarget:create()
   ::oCombo:create()
   ::oPBtarget:create()
RETURN self

* ------------------------------------------------------------------------- *
CLASS SaveDlg FROM SaveForm
EXPORTED:
   METHOD init
   METHOD create

   METHOD OpenTargetDir()
ENDCLASS

METHOD SaveDlg:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::SaveForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD SaveDlg:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
LOCAL i

   ::SaveForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   FOR i := 1 TO 26
      ::oCombo:AddItem(CHR(64+i))
   NEXT
   ::oCombo:setdata(1)

RETURN self

METHOD SaveDlg:OpenTargetDir(lShow)
   DEFAULT lShow TO .T.
   IF lShow
*     msgbox("ok")
   ENDIF
   CLEAR TYPEAHEAD
   PostAppEvent(xbeP_Keyboard,xbeK_F4,,::oCombo)
RETURN

* ------------------------------------------------------------------------- *
